import java.io.File;
import java.io.PrintWriter;
import java.util.Scanner;

public class Binary {

	public static void main(String[] args) throws Exception
	{
		new Binary().run();
	}
	
	private int binaryStrToInt(String str)
	{
		int res = 0;
		int mult = 1;
		for (int i = str.length() - 1; i >= 0; i--)
		{
			res += (str.charAt(i) - '0') * mult;
			mult *= 2;			
		}
		return res;
	}
	
	String longToBinaryStr(long x)
	{
		if (x == 0)
			return "0";
		String res = "";
		while (x > 0)
		{
			res += x % 2 == 0 ? '0' : '1';		
			x /= 2;
		}
		return new StringBuilder(res).reverse().toString();
	}
	
	private String genStr(int n, char c)
	{
		String res = "";
		for (int i = 0; i < n; i++)
		{
			res += c;
		}
		return res;
	}

	private void run() throws Exception 
	{
		Scanner in = new Scanner(new File("binary.in"));
		PrintWriter out = new PrintWriter(System.out);
		//PrintWriter out = new PrintWriter("binary.out");
		
		int testn = in.nextInt();
		in.nextLine();
		
		for (int testi = 0; testi < testn; testi++)
		{
			String str = in.nextLine();
			
			String[] arr = str.split(" ");
			if (arr.length != 2)
				throw new Exception("Error. Test:" + testi);
			if (arr[0].length() < 1 || arr[0].length() > 30)
				throw new Exception("Error. Test:" + testi);
			for (int i = 0; i < arr[0].length(); i++)
			{
				char c = arr[0].charAt(i);
				if (!(c == '0' || c == '1'))
					throw new Exception("Error. Test:" + testi);	
			}
			if (arr[0].length() > 1 && arr[0].charAt(0) != '1')
				throw new Exception("Error. Test:" + testi);
			
			if (arr[1].length() < 1 || arr[1].length() > 30)
				throw new Exception("Error. Test:" + testi);
			for (int i = 0; i < arr[1].length(); i++)
			{
				char c = arr[1].charAt(i);
				if (!(c == '0' || c == '1'))
					throw new Exception("Error. Test:" + testi);	
			}
			
			if (arr[1].length() > 1 && arr[1].charAt(0) != '1')
				throw new Exception("Error. Test:" + testi);

			
			int a = binaryStrToInt(arr[0]);
			String astr = arr[0];
			int alen = astr.length();
			int b = binaryStrToInt(arr[1]);
			String bstr = arr[1];
			int blen = bstr.length();
			
			String mult = longToBinaryStr(1L*a*b);
			int mlen = mult.length();
			int maxlen = Math.max(Math.max(alen, blen), mlen);
			out.println("Test " + (testi + 1));
			out.println(genStr(maxlen - alen, ' ') + astr);
			out.println(genStr(maxlen - blen, ' ') + bstr);
			
			out.println(genStr(mlen - Math.max(alen, blen), ' ') + genStr(Math.max(alen, blen), '-')); 
		
			
			int chars = maxlen - astr.length();
			for (int i = bstr.length() - 1; i >= 0; i--)
			{
				out.print(genStr(chars, ' '));
				chars--;
				
				if (bstr.charAt(i) == '0')
					out.println(genStr(alen, '0'));
				else 
					out.println(astr);
			}
			out.println(genStr(maxlen, '-'));
			out.println(genStr(maxlen - mlen, ' ') + mult);
			out.println();
		}
		
		in.close();
		out.close();
	}
}
