#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <algorithm>
#include <queue>
#include <assert.h>
#include <math.h>
using namespace std;

const int SZ = 200+10;
int a[SZ][SZ];
int len[SZ];
int from[SZ];

const int NO_PATH = SZ*10;

int bfs(int start, int n)
{
	queue<int> q;
	q.push(start);
	from[start]=-1;
	len[start] = 1;

	while(!q.empty())
	{
		int cur = q.front();
		q.pop();

		for(int i=0; i<n; i++)
		{
			if (a[cur][i] != 0 && i!= from[cur])
			{
				if (len[i] != 0) 
				{
					return (len[cur]-1) + (len[i]-1) + 1;
				}
				len[i] = len[cur]+1;
				from[i] = cur;
				q.push(i);
			}
		}
	}

	return NO_PATH;
}

int main()
{
	freopen("driving.in", "r", stdin);
	freopen("driving.out", "w", stdout);

	int test;
	cin >> test;
	for (int t = 0; t < test; t++)
	{
		int n, m;
		cin >> n >> m;
		assert(1 <= n && n <= 200);
		assert(1 <= m && m <= 1000);

		memset(a, 0, sizeof(a));
		for (int i = 0; i < m; i++)
		{
			int s, f;
			cin >> s >> f;
			assert(1 <= s && s <= n);
			assert(1 <= f && f <= n);
			assert(s != f);
			s --; f--;
			a[s][f]++; 
			a[f][s]++;
			assert(a[s][f] == 1);
			assert(a[f][s] == 1);
		}
		int ans = NO_PATH;
		for (int i = 0; i < n; i++)
		{
			memset(len, 0, sizeof(len));
			int curlen = bfs(i, n);

			ans = min(ans, curlen);
		}
		assert(ans != NO_PATH);
		cout << ans << endl;
	}

	return 0;
}
