import java.io.File;
import java.io.PrintWriter;
import java.util.HashSet;
import java.util.Scanner;

public class Equalizer {

	public static void main(String[] args) throws Exception
	{
		new Equalizer().run();
	}

	private void run() throws Exception 
	{
		Scanner in = new Scanner(new File("equalizer.in"));
		//PrintWriter out = new PrintWriter(System.out);
		PrintWriter out = new PrintWriter("equalizer.out");
		
		final int MOD = 1000*1000*1000;
		
		int testn = in.nextInt();
		for (int testi = 0; testi < testn; testi++)
		{
			int n = in.nextInt();
			int m = in.nextInt();
			if (m < 2 || m > 100000)
				throw new Exception("M out of bounds. Test:" + testi);
			if (n < 1 || n >= m)
				throw new Exception("N out of bounds. Test:" + testi);

			int k = in.nextInt();
			if (k < 0 || k > 100)
				throw new Exception("K out of bounds. Test:" + testi);
			HashSet<Integer> a = new HashSet<Integer>();
			for (int i = 0; i < k; i++)
			{
				int temp = in.nextInt();
				if (temp < 1 || temp > 100)
					throw new Exception("a[i] out of bounds. Test:" + testi);
				if (!a.contains(Integer.valueOf(temp)))
					a.add(Integer.valueOf(temp));
			}
			
			int s = in.nextInt();
			if (s < 0 || s > 100)
				throw new Exception("S out of bounds. Test:" + testi);
			HashSet<Integer> b = new HashSet<Integer>();
			for (int i = 0; i < s; i++)
			{
				int temp = in.nextInt();
				if (temp < 2 || temp > 100)
					throw new Exception("b[i] out of bounds. Test:" + testi);
				if (!b.contains(Integer.valueOf(temp)))
					b.add(Integer.valueOf(temp));
			}
			
			int[] mas = new int [m + 1];
			for (int i = 0; i <= m; i++)
			{
				mas[i] = 0;
			}
			mas[n] = 1;
			for (int i = n + 1; i < m; i++)
			{
				for (Integer aval : a) 
				{
					if (i - aval.intValue() >= n)
					{
						mas[i] += mas[i - aval.intValue()];
						mas[i] %= MOD;
					}
				}
				
				for (Integer bval : b) 
				{
					if (i % bval.intValue() == 0 && i/bval.intValue() >= n)
					{
						mas[i] += mas[i/bval.intValue()];
						mas[i] %= MOD;
					}
				}
			}
			
			for (Integer bval : b)
			{
				if (m % bval.intValue() == 0 && m/bval.intValue() >= n)
				{
					mas[m] += mas[m/bval.intValue()];
					mas[m] %= MOD;
				}
			}
			
			out.println(mas[m]);
		}
		
		in.close();
		out.close();
	}
}
