import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.InputMismatchException;
import java.util.Random;
import java.util.Scanner;
import java.util.StringTokenizer;


public class Ford {

	public static void main(String[] args) throws Exception
	{
		new Ford().run();
	}
	
	private int solve(int n, int[] a, long t)
	{
		int result = 0;
		for (int i = 0; i < n; i++)
		{
			result += t / a[i];
		}
		return result;
	}
	
	private void run() throws Exception 
	{
		Scanner in = new Scanner(new File("ford.in"));
		PrintWriter out = new PrintWriter(System.out);
		//PrintWriter out = new PrintWriter("ford.out");
		
		int testn = in.nextInt();
		for (int testi = 0; testi < testn; testi++)
		{
			int n = in.nextInt();
			if (n < 1 || n > 1000*100)
				throw new Exception("N out of bounds. Test:" + testi);

			int k = in.nextInt();
			if (k < 1 || k > 1000*1000*1000)
				throw new Exception("K out of bounds. Test:" + testi);
			
			int[] a = new int[n];
			
			for (int i = 0; i < n; i++)
			{
				a[i] = in.nextInt();
				if (a[i] < 1 || a[i] > 1000*1000*1000)
					throw new Exception("A[i] out of bounds. Test:" + testi);
			}
			
			long l = 0;
			long r = 1;
			while (solve(n, a, r) < k)
			{
				r *= 2;
			}
			
			while (r - l > 1)
			{
				long m = (l + r) / 2;
				if (solve(n, a, m) >= k)
					r = m;
				else 
					l = m;
			}
			out.println(r);
		}
		
		in.close();
		out.close();
	}
}
