//Ilyitch's solution of the problem "Ford"
#include <ctime>
#include <string>
#include <vector>
#include <sstream>
#include <fstream>
#include <iostream>
#include <iterator>

typedef long long ll;

bool CanProduce(const std::vector<ll> & t, ll k, ll bound)
{
	ll total = 0;
	for(size_t i = 0; i < t.size(); i++)
	{
		total += bound / t[i];
		if(total >= k)
		{
			return true;
		}
	}

	return false;
}

size_t Parse(const std::string & buf, std::vector<ll> & ret, size_t n)
{
	ret.clear();
	std::stringstream ss(buf);
	ll temp;
	while(ss >> temp)
	{
		ret.push_back(temp);
	}

	if(ret.size() != n)
	{
		std::cerr << "ERROR!" << std::endl;
		throw 1;
	}


	return ret.size();
}

int main(int argc, char * argv[])
{
	std::ifstream in("ford.in");
	int test;
	std::string buf;
	std::vector<ll> v;
	std::getline(in, buf);	
	std::stringstream ss(buf);
	for(ss >> test; test > 0; --test)
	{
		std::getline(in, buf);
		Parse(buf, v, 2);
		
		ll n = v[0];
		ll k = v[1];
		std::getline(in, buf);
		Parse(buf, v, n);

		ll a = 1;
		ll b = ll(1) << ll(62);
		while(b - a > 1)
		{
			ll m = (a + b) / 2;
			if(CanProduce(v, k, m))
			{
				b = m;
			}
			else
			{
				a = m + 1;
			}
		}

		if(CanProduce(v, k, a))
		{
			std::cout << a << std::endl;
		}
		else
		{
			std::cout << b << std::endl;
		}
	}

	std::cerr << double(clock()) / 1000 << std::endl;
	return 0;
}