#include <iostream>
#include <fstream>
#include <ctime>
#include <vector>
#include <cassert>
#include <map>
#include <algorithm>
#include <cmath>

using namespace std;

int N;
vector<int> A;

void validate_input()
{
	assert(0 <= N && N <= 100);
	for (int i = 0;i < N;i++)
		assert(0 <= A[i] && A[i] <= 1000000000);
}

int ans()
{
	int res = 0;

	while (true)
	{
		bool allZero = true;
		bool allDiv = true;
		for (int i = 0;i < N;i++)
		{
			if (A[i] >= 11 && A[i] <= 18)
			{
				res += 2;
				A[i] = 0;
			}

			if (A[i] != 0)
				allZero = false;

			if (A[i] % 10 != 0)
			{
				A[i] -= A[i] % 10;
				res++;
				allDiv = false;
			}
		}

		if (allZero)
			break;

		if (allDiv)
		{
			res++;
			for (int i = 0;i < N;i++)
				A[i] /= 10;
		}
	}

	return res;
}
/*
std::default_random_engine generator;

int rnd(int f, int t)
{
	std::uniform_int_distribution<int> distribution(f, t);
	return distribution(generator);
}

void gen_tests()
{
	int ii = RAND_MAX;

	freopen("c:\\temp\\holiday.in.gen", "w", stdout);

	generator.seed(time(NULL));

	for (int cc = 0;cc < 180;cc++)
	{
		N = rnd(1, 100);
		for (int i = 0;i < N;i++)
		{
			A.resize(N);
			A[i] = rnd(0, 1000000000);
		}
		validate_input();

		cout <<N <<endl;
		for (int i = 0;i < N;i++)
		{
			cout <<A[i];
			if (i == N - 1) cout <<endl;
			else cout <<" ";
		}
	}
}
*/
int main(int argc, char *argv[])
{
	//gen_tests();
	//return 0;

	freopen("holiday.in", "r", stdin);

	int tc;
	cin >>tc;

	for (int cc = 0;cc < tc;cc++)
	{		
		cin >>N;
		if (N == -1)
			break;
		A.resize(N);
		for (int i = 0;i < N;i++)
			cin >>A[i];

		validate_input();
		//cout <<"Case " <<cc + 1 <<": ";
		cout <<ans() <<endl;
	}

	return 0;
}
