#include <iostream>
#include <fstream>
#include <ctime>
#include <vector>
#include <cassert>
#include <map>
#include <algorithm>
#include <cmath>

using namespace std;

const long long MOD = 2017;

int N, K;

//  
int C(int n, int k) {
	int res = 1;
	for (int i=n-k+1; i<=n; ++i)
		res *= i;
	for (int i=2; i<=k; ++i)
		res /= i;

	return res;
}

int fact(int n)
{
	return n <= 1 ? 1 : n * fact(n-1);
}

//       MOD
long long pfast(int x, int p)
{
	if (p == 0)
		return 1;
	if (p == 1)
		return x;

	long long r = pfast(x, p / 2) % MOD;
	return (r * r * ((p % 2 == 1) ? x : 1)) % MOD;
}

//   .
int gcd (int a, int b, int &x, int &y) {
	if (a == 0) {
		x = 0; y = 1;
		return b;
	}
	int x1, y1;
	int d = gcd (b%a, a, x1, y1);
	x = y1 - (b / a) * x1;
	y = x1;
	return d;
}

int mod_multiplicative_inverse(int a)
{
	int x, y;
	gcd(a, MOD, x, y);

	return x;
}

//   -  
// https://ru.wikipedia.org/wiki/%D0%A7%D0%B8%D1%81%D0%BB%D0%B0_%D0%A1%D1%82%D0%B8%D1%80%D0%BB%D0%B8%D0%BD%D0%B3%D0%B0_%D0%B2%D1%82%D0%BE%D1%80%D0%BE%D0%B3%D0%BE_%D1%80%D0%BE%D0%B4%D0%B0
//      MOD.
//       k!    , 
//   :
// a/b mod M = a * modular_multiplicative_inverse(k!) mod M.   gcd(a, k!)   1 (  ).
// 
int main(int argc, char *argv[])
{
	freopen("kohinoor.in", "r", stdin);

	int tc;
	cin >>tc;

	for (int cc = 0;cc < tc;cc++)
	{		
		cin >>N >> K;
		assert(1 <= N && N <= 1000000000);
		assert(1 <= K && K <= min(N, 10));

		int res = 0;
		int f = fact(K);

		for (int j = 0;j <= K;j++)
		{
			int cur = C(K, j) * pfast(j, N);
			if ((K + j) % 2 == 1)
				cur *= -1;

			res = ((res + cur + MOD) % MOD);
		}

		res = (mod_multiplicative_inverse(f) * res) % MOD;
		res = (res + MOD) % MOD;
		cout <<res <<endl;
	}

	return 0;
}
